--- sh-utils-2.0.12/src/uname.c.sysinfo	Sat Dec 15 17:51:54 2001
+++ sh-utils-2.0.12/src/uname.c	Thu Aug 29 21:32:58 2002
@@ -228,18 +228,44 @@
       char processor[257];
       if (0 <= sysinfo (SI_ARCHITECTURE, processor, sizeof processor))
 	element = processor;
+#else
+      struct utsname u;
+      uname(&u);
+      element = u.machine;
+#ifdef linux
+      if(!strcmp(element, "i686")) { /* Check for Athlon */
+	      char cinfo[1024];
+	      FILE *f=fopen("/proc/cpuinfo", "r");
+	      if(f) {
+		      while(fgets(cinfo, 1024, f)) {
+			      if(!strncmp(cinfo, "vendor_id", 9)) {
+				      if(strstr(cinfo, "AuthenticAMD"))
+					      element="athlon";
+				      break;
+			      }
+		      }
+		      fclose(f);
+	      }
+      }
+#endif
 #endif
       print_element (element);
     }
 
   if (toprint & PRINT_HARDWARE_PLATFORM)
     {
-      char const *element = "unknown";
+      char *element = "unknown";
 #if defined (HAVE_SYSINFO) && defined (SI_PLATFORM)
       char hardware_platform[257];
       if (0 <= sysinfo (SI_PLATFORM,
 			hardware_platform, sizeof hardware_platform))
 	element = hardware_platform;
+#else
+      struct utsname u;
+      uname(&u);
+      element = u.machine;
+      if(strlen(element)==4 && element[0]=='i' && element[2]=='8' && element[3]=='6')
+	      element[1]='3';
 #endif
       print_element (element);
     }
